%global meadalpha %{nil}
%global meadrel %{nil}
%global serial 14
%global commitid 75c0134894e04fc1bfbaec735af59eb63f47d6a8

%global version_major 1
%global version_minor 1
%global version_micro 1k
%define soversion 1.1

%{?scl:%scl_package openssl}
%{!?scl:%global pkg_name %{name}}

%global _performance_build 1

Summary: Utilities from the general purpose cryptography library with TLS implementation
Name: %{?scl_prefix}openssl
Version: 1.1.1k
Release: %{serial}%{?dist}
Epoch: 1
# We have to remove certain patented algorithms from the openssl source
# tarball with the hobble-openssl script which is included below.
# The original openssl upstream tarball cannot be shipped in the .src.rpm.
Source: openssl-%{commitid}.tar.gz
Source2: Makefile.certificate
Source6: make-dummy-cert
Source7: renew-dummy-cert
# All the patches out, some are applied in the source, some are not useful in JBCS .e.g.fips related
License: OpenSSL
Group: System Environment/Libraries
URL: http://www.openssl.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%{?scl:Requires: %scl_runtime}

BuildRequires: gcc
BuildRequires: coreutils, krb5-devel, perl, sed, zlib-devel, /usr/bin/cmp
BuildRequires: patchelf
BuildRequires: /usr/bin/rename
BuildRequires: /usr/bin/pod2man
BuildRequires: perl(Test::Harness), perl(Test::More), perl(Math::BigInt)
BuildRequires: perl(Module::Load::Conditional), perl(File::Temp)
BuildRequires: perl(FindBin), perl(lib), perl(File::Compare), perl(File::Copy)
BuildRequires: perl(Time::HiRes)

Requires: coreutils, make
Requires: %{name}-libs%{?_isa} = %{epoch}:%{version}-%{release}

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%package libs
Summary: A general purpose cryptography library with TLS implementation
Group: System Environment/Libraries
Requires: ca-certificates >= 2008-5

%description libs
OpenSSL is a toolkit for supporting cryptography. The openssl-libs
package contains the libraries that are used by various applications which
support cryptographic algorithms and protocols.

%package devel
Summary: Files for development of applications which will use OpenSSL
Group: Development/Libraries
Requires: %{name}-libs%{?_isa} = %{epoch}:%{version}-%{release}
Requires: krb5-devel%{?_isa}, zlib-devel%{?_isa}
Requires: pkgconfig

%package static
Summary:  Libraries for static linking of applications which will use OpenSSL
Requires: %{name}-devel%{?_isa} = %{epoch}:%{version}-%{release}

%description static
OpenSSL is a toolkit for supporting cryptography. The openssl-static
package contains static libraries needed for static linking of
applications which support various cryptographic algorithms and
protocols.

%description devel
OpenSSL is a toolkit for supporting cryptography. The openssl-devel
package contains include files needed to develop applications which
support various cryptographic algorithms and protocols.

%package perl
Summary: Perl scripts provided with OpenSSL
Requires: perl-interpreter
Requires: %{name}%{?_isa} = %{epoch}:%{version}-%{release}

%description perl
OpenSSL is a toolkit for supporting cryptography. The openssl-perl
package provides Perl scripts for converting certificates and keys
from other formats to the formats used by the OpenSSL toolkit.

%package zip
Summary: Zip distribution of openssl

%description zip
A subpackage used to create standalone openssl zip file

# Excludes files in %%{_libdir} from being added to the list of what the package provides
%global __provides_exclude_from ^(%{_libdir}/.*)$
%global __requires_exclude ^(libcrypto[.]so.*)$
%global __requires_exclude ^(libssl[.]so.*)$

%prep
%setup -q -n openssl-%{commitid}

%build
# Figure out which flags we want to use.
# default
sslarch=%{_os}-%{_target_cpu}
%ifarch x86_64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch s390x
sslarch="linux64-s390x"
%endif
%ifarch aarch64
sslarch=linux-aarch64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch ppc64le
sslarch="linux-ppc64le"
sslflags=enable-ec_nistp_64_gcc_128
%endif

# Add -Wa,--noexecstack here so that libcrypto's assembler modules will be
# marked as not requiring an executable stack.
# Also add -DPURIFY to make using valgrind with openssl easier as we do not
# want to depend on the uninitialized memory as a source of entropy anyway.
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wa,--noexecstack  -DPURIFY $RPM_LD_FLAGS"

export HASHBANGPERL=/usr/bin/perl

# ia64, x86_64, ppc are OK by default
# Configure the build tree.  Override OpenSSL defaults with known-good defaults
# usable on all platforms.  The Configure script already knows to use -fPIC and
# RPM_OPT_FLAGS, so we can skip specifiying them here.
# Fedora specifies a crypto-policy location, but this path is not in RHEL-6 so we ommit it

# Rewrite our build number
perl -pi -e "s;\@openssl_release_version\@;%{release};g" include/openssl/opensslv.h

./Configure \
	--prefix=%{_prefix} --openssldir=%{_sysconfdir}/pki/tls \
	--libdir=`basename %{_libdir}` \
	zlib enable-camellia enable-seed enable-rfc3779 \
	enable-cms enable-md2 enable-rc5\
	enable-weak-ssl-ciphers \
	no-mdc2 no-ec2m no-sm2 no-sm4 \
	shared ${sslarch} $RPM_OPT_FLAGS '-DDEVRANDOM="\"/dev/urandom\""'


make

cp -f %{SOURCE2} .

# Clean up the .pc files
for i in libcrypto.pc libssl.pc openssl.pc ; do
  sed -i '/^Libs.private:/{s/-L[^ ]* //;s/-Wl[^ ]* //}' $i
done


%check
# Verify that what was compiled actually works.

# Set rpath in openssl binary
patchelf --set-rpath '$ORIGIN/../lib64/' $RPM_BUILD_ROOT/%{_bindir}/openssl
for i in $RPM_BUILD_ROOT%{_libdir}/*.so.%{version} ; do
    patchelf --set-rpath '$ORIGIN/' $i
done


LD_LIBRARY_PATH=`pwd`${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
export LD_LIBRARY_PATH
OPENSSL_ENABLE_MD5_VERIFY=1
export OPENSSL_ENABLE_MD5_VERIFY

make test || true

%define __provides_exclude_from %{_libdir}/openssl


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
# Install OpenSSL.
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir},%{_mandir},%{_libdir}/openssl}
make DESTDIR=$RPM_BUILD_ROOT install

rename so.%{soversion} so.%{version} $RPM_BUILD_ROOT%{_libdir}/*.so.%{soversion}
for lib in $RPM_BUILD_ROOT%{_libdir}/*.so.%{version} ; do
	chmod 755 ${lib}
	ln -s -f `basename ${lib}` $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`
	ln -s -f `basename ${lib}` $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`.%{soversion}
done
# Install a makefile for generating keys and self-signed certs, and a script
# for generating them on the fly.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs
install -m755 %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/make-dummy-cert
install -m755 %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/renew-dummy-cert

# Move runable perl scripts to bindir
mv $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/misc/*.pl $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/misc/tsget $RPM_BUILD_ROOT%{_bindir}

# Drop the SSLv3 methods from includes
sed -i '/ifndef OPENSSL_NO_SSL3_METHOD/,+4d' $RPM_BUILD_ROOT%{_includedir}/openssl/ssl.h

# Make sure we actually include the headers we built against.
for header in $RPM_BUILD_ROOT%{_includedir}/openssl/* ; do
	if [ -f ${header} -a -f include/openssl/$(basename ${header}) ] ; then
		install -m644 include/openssl/`basename ${header}` ${header}
	fi
done

# Rename man pages so that they don't conflict with other system man pages.
pushd $RPM_BUILD_ROOT%{_mandir}
ln -s -f config.5 man5/openssl.cnf.5
for manpage in man*/* ; do
	if [ -L ${manpage} ]; then
		TARGET=`ls -l ${manpage} | awk '{ print $NF }'`
		ln -snf ${TARGET}ssl ${manpage}ssl
		rm -f ${manpage}
	else
		mv ${manpage} ${manpage}ssl
	fi
done
for conflict in passwd rand ; do
	rename ${conflict} ssl${conflict} man*/${conflict}*
# Fix dangling symlinks
        manpage=man1/openssl-${conflict}.*
        if [ -L ${manpage} ] ; then
                ln -snf ssl${conflict}.1ssl ${manpage}
        fi
done
popd

mkdir -m755 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA
mkdir -m700 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/private
mkdir -m755 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/certs
mkdir -m755 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/crl
mkdir -m755 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/newcerts

# Ensure the openssl.cnf timestamp is identical across builds to avoid
# mulitlib conflicts and unnecessary renames on upgrade
touch -r %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/openssl.cnf
touch -r %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/ct_log_list.cnf

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/openssl.cnf.dist
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/ct_log_list.cnf.dist

# Symbolic link to OPENSSLDIR
mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/pki
ln -s ../../../etc/pki/tls $RPM_BUILD_ROOT%{_prefix}/etc/pki

LD_LIBRARY_PATH=`pwd`${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
export LD_LIBRARY_PATH

#Create a temporary directory for the zip creation
mkdir -p $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/
pushd $RPM_BUILD_ROOT
cp -r --parents .%{_sysconfdir}/pki/tls \
.%{_sysconfdir}/pki/tls/certs \
.%{_sysconfdir}/pki/tls/ct_log_list.cnf \
.%{_sysconfdir}/pki/tls/misc \
.%{_sysconfdir}/pki/tls/private \
.%{_sysconfdir}/pki/tls/openssl.cnf \
.%{_sysconfdir}/pki/CA \
.%{_sysconfdir}/pki/CA/certs \
.%{_sysconfdir}/pki/CA/crl \
.%{_sysconfdir}/pki/CA/newcerts \
.%{_sysconfdir}/pki/CA/private \
.%{_bindir}/openssl \
.%{_bindir}/make-dummy-cert \
.%{_bindir}/renew-dummy-cert \
.%{_bindir}/CA.pl \
.%{_bindir}/c_rehash \
.%{_bindir}/tsget \
.%{_bindir}/tsget.pl \
.%{_libdir}/libcrypto.so.%{version} \
.%{_libdir}/libcrypto.so.%{soversion} \
.%{_libdir}/libssl.so.%{version} \
.%{_libdir}/libssl.so.%{soversion} \
.%{_libdir}/openssl \
$RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/
pushd $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/
# Hack to remove the /opt/rh/jbcs-httpd24/root directory from the path
mv opt/rh/jbcs-httpd24/root/usr/* .
mv opt/rh/jbcs-httpd24/root/* .
rm -rf opt usr
popd
popd

pushd $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/
#Change certain files' permissions
chmod 0755 bin/openssl \
lib64/libcrypto.so.%{version} \
lib64/libcrypto.so.%{soversion} \
lib64/libssl.so.%{version} \
lib64/libssl.so.%{soversion} \
lib64/openssl
popd

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
pushd $RPM_BUILD_ROOT/temp/
# All of this stuff is what happens with %%doc :/
pushd jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/
# Create the share directory for docs
mkdir -p share/{doc,man,licenses}
mkdir -p share/man/{man1,man5,man7}
cp -r $RPM_BUILD_ROOT%{_mandir}/man1*/[ABD-Zabcd-z]* share/man/man1/
cp -r $RPM_BUILD_ROOT%{_mandir}/man5*/* share/man/man5/
cp -r $RPM_BUILD_ROOT%{_mandir}/man7*/* share/man/man7/
# Apparently some magic gzipping occurs somewhere for manpages, so manually handle that here
for manpage in $(find share/man*/* -type f); do
    gzip $manpage
done
for manpage in $(find share/man*/* -type l); do
    # This release seemingly added a bunch of openssl-N links, let's remove those
    if [[ $manpage == share/man*/*/openssl-* ]]; then
        unlink $manpage
        continue
    fi
    target=$(readlink $manpage)
    unlink $manpage
    ln -s ${target}.gz ${manpage}.gz
done
mkdir share/doc/%{name}-%{version_major}.%{version_minor}.%{version_micro}
mkdir share/doc/%{name}-devel-%{version_major}.%{version_minor}.%{version_micro}
mkdir share/licenses/%{name}
mkdir share/licenses/%{name}-libs
cp %{SOURCE2} share/doc/%{name}-%{version_major}.%{version_minor}.%{version_micro}
pushd %{_builddir}/openssl-%{commitid}
    cp FAQ NEWS README README.FIPS INSTALL $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/share/doc/%{name}-%{version_major}.%{version_minor}.%{version_micro}
    cp CHANGES doc/dir-locals.example.el doc/openssl-c-indent.el $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/share/doc/%{name}-devel-%{version_major}.%{version_minor}.%{version_micro}
    cp LICENSE $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/share/licenses/%{name}
    cp LICENSE $RPM_BUILD_ROOT/temp/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/%{pkg_name}/share/licenses/%{name}-libs
popd
popd
# End %%doc recreation
# Now zip it all up!

# Set rpath in openssl binary
patchelf --set-rpath '$ORIGIN/../lib64/' ./jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}/openssl/bin/openssl

zip -q -r -y jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}-RHEL%{?rhel}-%{_arch}.zip .
mv jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}-RHEL%{?rhel}-%{_arch}.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
popd
rm -rf $RPM_BUILD_ROOT/temp

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc FAQ NEWS INSTALL README README.FIPS Makefile.certificate
%attr(0755,root,root) %{_bindir}/make-dummy-cert
%attr(0755,root,root) %{_bindir}/renew-dummy-cert
%attr(0755,root,root) %{_bindir}/openssl
%attr(0644,root,root) %{_mandir}/man1*/[ABD-Zabcd-z]*
%attr(0644,root,root) %{_mandir}/man5*/*
%attr(0644,root,root) %{_mandir}/man7*/*
%exclude %{_mandir}/man1*/*.pl*
%exclude %{_mandir}/man1*/c_rehash*
%exclude %{_mandir}/man1*/tsget*
%exclude %{_mandir}/man1*/openssl-tsget*

%files libs
%defattr(-,root,root)
%{!?_licensedir:%global license %%doc}
%license LICENSE
%dir %{_sysconfdir}/pki/tls
%dir %{_sysconfdir}/pki/tls/certs
%dir %{_sysconfdir}/pki/tls/misc
%dir %{_sysconfdir}/pki/tls/private
%dir %{_prefix}/etc
%dir %{_prefix}/etc/pki
%{_prefix}/etc/pki/tls
%config(noreplace) %{_sysconfdir}/pki/tls/openssl.cnf
%config(noreplace) %{_sysconfdir}/pki/tls/ct_log_list.cnf
%{_libdir}/libcrypto.so.%{version}
%{_libdir}/libcrypto.so.%{soversion}
%{_libdir}/libssl.so.%{version}
%{_libdir}/libssl.so.%{soversion}
%attr(0755,root,root) %{_libdir}/libcrypto.so
%attr(0755,root,root) %{_libdir}/libssl.so
%attr(0755,root,root) %{_libdir}/openssl

%files devel
%defattr(-,root,root)
%doc CHANGES doc/dir-locals.example.el doc/openssl-c-indent.el
%{_prefix}/include/openssl
%attr(0755,root,root) %{_libdir}/*.so
%attr(0644,root,root) %{_mandir}/man3*/*
%attr(0644,root,root) %{_libdir}/pkgconfig/*.pc

%files static
%{_libdir}/*.a

%files perl
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/c_rehash
%attr(0755,root,root) %{_bindir}/*.pl
%attr(0755,root,root) %{_bindir}/tsget
%attr(0644,root,root) %{_mandir}/man1*/*.pl*
%attr(0644,root,root) %{_mandir}/man1*/c_rehash*
%attr(0644,root,root) %{_mandir}/man1*/tsget*
%attr(0644,root,root) %{_mandir}/man1*/openssl-tsget*
%dir %{_sysconfdir}/pki/CA
%dir %{_sysconfdir}/pki/CA/private
%dir %{_sysconfdir}/pki/CA/certs
%dir %{_sysconfdir}/pki/CA/crl
%dir %{_sysconfdir}/pki/CA/newcerts

%files zip
%defattr(-,root,root)
%{_javadir}/jbossas-fordev/jbcs-%{pkg_name}-%{version_major}.%{version_minor}.%{version_micro}-RHEL%{?rhel}-%{_arch}.zip

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%changelog
* Fri Apr 21 2023 Mladen Turk <mturk@redhat.com> - 1.1.1k-14
- Apply patches for CVE-2022-4304 CVE-2022-4450
  CVE-2023-0215 and CVE-2023-0286

* Mon Oct 31 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-13
- Apply patches for CVE-2022-1292 and CVE-2022-2068

* Wed Sep 14 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.1.1k-12
- Built by CPaaS

* Wed Aug 24 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-11
- Update of openssl.cnf file with the upper bound values that are currently allowed
- Apply openssl-1.1.1-replace-expired-certs.patch

* Tue Aug 23 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.1.1k-10
- Built by CPaaS

* Sat Jun 25 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.1.1k-9
Built by CPaaS



* Sun Jun 19 2022 cpaas-ops <cpaas-ops@redhat.com> - 1.1.1k-8
Built by CPaaS



* Thu Mar 24 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-7
- Add openssl-1.1.1-cve-2022-0778.patch

* Thu Feb 10 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-5
- Fix JBCS-1133

* Thu Feb 03 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-4
- Add missing evp-kdf api

* Thu Feb 03 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-3
- Use private package provides filter

* Wed Feb 02 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-2
- Rebuild ... no functional change

* Fri Jan 28 2022 Mladen Turk <mturk@redhat.com> - 1.1.1k-1
- Upgrade to version 1.1.1k
